package com.bzd.web.controller.mdyy;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.mdyy.SMdyyglMdysjqMbxsjhService;

import java.util.List;

/**
*
* 慢病销售计划表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "mdyygl/smdyyglmdysjqmbxsjh")
public class SMdyyglMdysjqMbxsjhController extends BaseController {

    // 页面跳转前缀
    private String prefix = "mdyy";

    @Autowired
    private SMdyyglMdysjqMbxsjhService sMdyyglMdysjqMbxsjhService;

    /**
    * 慢病销售计划表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("mdyygl:mdyy:view")
    @GetMapping("/sMdyyglMdysjqMbxsjhAdd")
    public String add() {
        return prefix + "/SMdyyglMdysjqMbxsjhAdd";
    }

    /**
    * 慢病销售计划表 新增
    *
    * @return
    */
    @Log(title = "慢病销售计划表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sMdyyglMdysjqMbxsjhAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sMdyyglMdysjqMbxsjhService.addSMdyyglMdysjqMbxsjh(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 慢病销售计划表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("mdyygl:mdyy:view")
    @GetMapping("/sMdyyglMdysjqMbxsjhView")
    public String smdyyglmdysjqmbxsjhListView() {
        return prefix + "/SMdyyglMdysjqMbxsjhList";
    }

    /**
    * 慢病销售计划表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:sMdyyglMdysjqMbxsjhList")
    @PostMapping("/sMdyyglMdysjqMbxsjhList")
    @ResponseBody
    public TableDataInfo smdyyglmdysjqmbxsjhList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sMdyyglMdysjqMbxsjhService.findSMdyyglMdysjqMbxsjhList(pd);
        return getDataTable(pageData);
    }

    /**
    * 慢病销售计划表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:remove")
    @Log(title = "慢病销售计划表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sMdyyglMdysjqMbxsjhRemove")
    @ResponseBody
    public AjaxResult smdyyglmdysjqmbxsjhRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sMdyyglMdysjqMbxsjhService.SMdyyglMdysjqMbxsjhRemove(pd);
        return toAjax(integer);
    }

    /**
    * 慢病销售计划表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:edit")
    @GetMapping("/sMdyyglMdysjqMbxsjhEdit/{id}")
    public String smdyyglmdysjqmbxsjhView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sMdyyglMdysjqMbxsjhService.findSMdyyglMdysjqMbxsjhList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/smdyyglmdysjqmbxsjhPageEdit";
        }
        return prefix+ "/smdyyglmdysjqmbxsjhEdit";
    }

    /**
    * 慢病销售计划表保存修改的数据
    */
    @RequiresPermissions("mdyygl:mdyy:edit")
    @Log(title = "慢病销售计划表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sMdyyglMdysjqMbxsjhEdit")
    @ResponseBody
    public AjaxResult smdyyglmdysjqmbxsjhEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sMdyyglMdysjqMbxsjhService.updateSMdyyglMdysjqMbxsjh(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表smdyyglmdysjqmbxsjh with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表smdyyglmdysjqmbxsjh with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
